/**
 *  Copyright © 2025, Luis Andrés Lange <https://javacomm.net>
 *
 *  Previously released under Apache License 2.0; now licensed under MPL 2.0.
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;



public class ONHOOK extends MESSAGE {

  public final static String RECEIVER_PSEUDOID = "RECEIVER_PSEUDOID";
  public final static String CALLER_PSEUDOID = "CALLER_PSEUDOID";
  public final static String TO = "TO";
  public final static String SIGNAL = "SIGNAL";
  public final static String AUDIOKEY = "AUDIOKEY";

  private String receiverPseudoid;
  private String callerPseudoid;
  private Boolean to;
  private boolean signal;
  private String audiokey;

  public String getCallerPseudoid() {
    return callerPseudoid;
  }



  public String getAudiokey() {
    return audiokey;
  }



  public String getReceiverPseudoid() {
    return receiverPseudoid;
  }



  public boolean isSignal() {
    return signal;
  }



  /**
   * Wer hat aufgelegt?
   * 
   * @return {@code true}, der Caller hat aufgelegt
   */
  public Boolean isTo() {
    return to;
  }



  /**
   * Der Anrufer.
   * 
   * @param callerUserid
   *                     dieser Anwender
   */
  public void setCallerPseudoid(String callerPseudoid) {
    this.callerPseudoid = callerPseudoid;
  }



  public void setAudiokey(String conferencekey) {
    this.audiokey = conferencekey;
  }



  /**
   * Der Empfänger.
   * 
   * @param selfUserid
   *                   dieser Anwender
   */
  public void setReceiverPseudoid(String selfUserid) {
    receiverPseudoid = selfUserid;
  }



  /**
   * Busy tone einschalten oder aussschalten
   * 
   * @param signal
   *               {@code true}, busy tone soll abgespielt werden
   */
  public void setSignal(boolean signal) {
    this.signal = signal;
  }



  /**
   * Hat der Caller oder der Receiver aufgelegt?
   * 
   * @param to
   *           {@code true}, der Caller hat aufgelegt, {@code false} der Receiver
   *           hat aufgelegt
   */
  public void setTo(Boolean to) {
    this.to = to;
  }



  @Override
  public String toString() {
    GsonBuilder builder = new GsonBuilder();
    builder.registerTypeHierarchyAdapter(ONHOOK.class, new OnhookSerializer());
    Gson gson = builder.create();
    return gson.toJson(this);
  }

}
